# audiodynamic

This element can act as a compressor or expander. A compressor changes the amplitude of all samples above a specific threshold with a specific ratio, a expander does the same for all samples below a specific threshold. If soft-knee mode is selected the ratio is applied smoothly.

## Example launch line

     gst-launch-1.0 audiotestsrc wave=saw ! audiodynamic characteristics=soft-knee mode=compressor threshold=0.5 ratio=0.5 ! alsasink
     gst-launch-1.0 filesrc location="melo1.ogg" ! oggdemux ! vorbisdec ! audioconvert ! audiodynamic characteristics=hard-knee mode=expander threshold=0.2 ratio=4.0 ! alsasink
     gst-launch-1.0 audiotestsrc wave=saw ! audioconvert ! audiodynamic ! audioconvert ! alsasink

## Hierarchy

    GObject
        ╰──GInitiallyUnowned
            ╰──GstObject
                ╰──GstElement
                    ╰──GstBaseTransform
                        ╰──GstAudioFilter
                            ╰──audiodynamic

## Factory details

Authors: – Sebastian Dröge <slomo@circular-chaos.org></slomo@circular-chaos.org>

Classification: – `Filter/Effect/Audio`

Rank – none

Plugin – audiofx

Package – GStreamer Good Plug-ins

## Pad Templates

### `sink`

    audio/x-raw:
             format: { S16LE, F32LE }
               rate: [ 1, 2147483647 ]
           channels: [ 1, 2147483647 ]
             layout: { (string)interleaved, (string)non-interleaved }

Presence – always

Direction – sink

Object type – GstPad

### `src`

    audio/x-raw:
             format: { S16LE, F32LE }
               rate: [ 1, 2147483647 ]
           channels: [ 1, 2147483647 ]
             layout: { (string)interleaved, (string)non-interleaved }

Presence – always

Direction – src

Object type – GstPad

## Properties

### characteristics

    “characteristics” Audio-dynamic-characteristics *

Selects whether the ratio should be applied smooth (soft-knee) or hard (hard-knee).

Flags : Read / Write

Default value : hard-knee (0)

### mode

    “mode” Audio-dynamic-mode *

Selects whether the filter should work on loud samples (compressor) orquiet samples (expander).

Flags : Read / Write

Default value : compressor (0)

### ratio

    “ratio” gfloat

Ratio that should be applied

Flags : Read / Write

Default value : 1

### threshold

    “threshold” gfloat

Threshold until the filter is activated

Flags : Read / Write

Default value : 0

## Named constants

### Audio-dynamic-characteristics

#### Members

`hard-knee` (0) – Hard Knee (default)
`soft-knee` (1) – Soft Knee (smooth)

### Audio-dynamic-mode

#### Members

`compressor` (0) – Compressor (default)
`expander` (1) – Expander

The results of the search are